#include <stdlib.h>
#include <stdio.h>
#include "error_stuff.h"
#include "util.h"

void reverse_nibbles(FILE *infile, long offset, size_t size)
{
    unsigned char buf[0x800];

    while (size > 0)
    {
        size_t bytes_to_fix = sizeof(buf);
        if (bytes_to_fix > size) bytes_to_fix = size;

        CHECK_ERRNO(fseek(infile, offset, SEEK_SET) != 0, "fseek");

        size_t bytes_read = fread(buf, 1, bytes_to_fix, infile);
        //fprintf(stderr,"offset=%lx bytes_to_fix=%lx bytes_read=%lx\n",offset,(long)bytes_to_fix,(long)bytes_read);
        CHECK_FILE(bytes_read != bytes_to_fix, infile, "fread");

        for (int i = 0; i < bytes_to_fix; i++)
        {
            buf[i] = ((buf[i] & 0xf0) >> 4) | ((buf[i] & 0x0f) << 4);
        }

        CHECK_ERRNO(fseek(infile, offset, SEEK_SET) != 0, "fseek");

        size_t bytes_written = fwrite(buf, 1, bytes_to_fix, infile);
        CHECK_FILE(bytes_written != bytes_to_fix, infile, "fwrite");

        size -= bytes_to_fix;
        offset += bytes_to_fix;
    }
}

int main(int argc, char **argv)
{
    if (argc != 2)
    {
        fprintf(stderr,"usage: mpeg_nibble_reverse file.WAV\n");
        exit(EXIT_FAILURE);
    }

    FILE *infile = fopen(argv[1], "r+b");
    CHECK_ERRNO(!infile, "fopen");

    CHECK_ERRNO(fseek(infile, 0, SEEK_END) == -1, "fseek");
    const long file_size = ftell(infile);
    CHECK_ERRNO(file_size == -1, "ftell");
    reverse_nibbles(infile, 4, file_size-4);
}
